;*
;* Hello World!2
;*
;* This is like the first Hello World! for raspberry pi .
;* but with more commands added.
;* It shows how to embedded and display a bmp image
;* change font color and string location
;* print string, use a sub function
;* copy buffer to screen and end
;*
include 'DexBasic\DexBasic.inc' 		   ; set up everything and stores our macros etc

load   MyBmpImage, ScreenBuffer 		   ; load our bmp image to off screen buffer
color  0x007db251				   ; set color of font (Raspberry pi leaf green)
locate 10,15					   ; set the location for the next print
print  "DexBasic is Cool"			   ; prints string and move to next line
color  0x00dc4e81				   ; set color of font (Raspberry red)
print  "Raspberry pi is Cool "			   ; prints string and move to next line
print  "The two together are super Cool"	   ; prints string and move to next line

color  0x0057ffff				   ; set color of font
locate 10,117					   ; set the location for the next print
print  "With the ease of Basic" 		   ; prints string and move to next line
print  "and the power of ASM "			   ; prints string and move to next line

color  0x00ffffaf				   ; set color of font
locate 10,219					   ; set the location for the next print
print  "This demo uses the basic commands:"	   ; prints string and move to next line
print  " "					   ; prints space and move to next line
print  "   cls" 				   ; prints string and move to next line
print  "   goto"				   ; prints string and move to next line
print  "   color"				   ; prints string and move to next line
print  "   locate"				   ; prints string and move to next line
print  "   print"				   ; prints string and move to next line
print  "   gosub"				   ; prints string and move to next line
print  "   return"				   ; prints string and move to next line
print  "   sync"				   ; prints string and move to next line
print  "   end" 				   ; prints string and move to next line
print  "   load"				   ; prints string and move to next line
print  " "					   ; prints space and move to next line
gosub  MyFunction				   ; go to a sub function
goto   JumpOver 				   ; goes to the label JumpOver

print  "This should not be printed."		   ; prints string (but it should not get run)

align 4 					   ; make sure the next bit aligned on a 4 byte boundary
JumpOver:					   ; a label
sync						   ; write screen buffer to screen
end						   ; end program, just loop over and over again

align 4 					   ; make sure the next bit aligned on a 4 byte boundary
MyFunction:					   ; name and address of sub function
substart					   ; this save regs other than r0-r3
print  "This is printed by sub function"	   ; the code to run in the sub function (print string)
return						   ; restores reg (other than r0-r3) and returns to just after the gosub.


align 4 					   ; make sure the next bit aligned on a 4 byte boundary
MyBmpImage:					   ; the name and address of our bmp image
file 'Images\Bg.bmp'				   ; this tells the assembler where to load the bmp from.
align 4 					   ; make sure the next bit aligned on a 4 byte boundary
ProgramSize:					   ; this label is so we can work out, the size of this program
ScreenBuffer:					   ; this label is where our off screen buffer is